--
-- Alex2009sWeltSeilahn
--
-- @author Alex2009(www.Alex2009.de)
-- @date  21/10/2013 (dd/mm/yyyy)
--
-- Hinweis: das kopieren von Sourcecode ist strafbar nach UrhG 2.1

--[[
Dieses Werk bzw. Inhalt von Alex2009 ist lizenziert unter einer Creative Commons Namensnennung - Nicht-kommerziell - Keine Bearbeitung 3.0 Unported Lizenz.(http://creativecommons.org/licenses/by-nc-nd/3.0/deed.de)
ber diese Lizenz hinausgehende Erlaubnisse knnen Sie unter http://www.Alex2009.de erhalten. 
]]

fireworkPlaceable = {};
fireworkPlaceable_mt = Class(fireworkPlaceable, Placeable);
InitObjectClass(fireworkPlaceable, "fireworkPlaceable");

function fireworkPlaceable:new(isServer, isClient, customMt)
    local self = Placeable:new(isServer, isClient, fireworkPlaceable_mt);
    registerObjectClassName(self, "fireworkPlaceable");
    return self;
end;

function fireworkPlaceable:delete()
    if self.ParticleSyS ~= nil then
        Utils.deleteParticleSystem(self.ParticleSyS[1]);
        Utils.deleteParticleSystem(self.ParticleSyS[2]);
        Utils.deleteParticleSystem(self.ParticleSyS[3]);
        Utils.deleteParticleSystem(self.ParticleSyS[4]);
        Utils.deleteParticleSystem(self.ParticleSyS[5]);
        Utils.deleteParticleSystem(self.ParticleSyS[6]);
        Utils.deleteParticleSystem(self.ParticleSyS[7]);
        Utils.deleteParticleSystem(self.ParticleSyS[8]);
    end;
    unregisterObjectClassName(self);
    fireworkPlaceable:superClass().delete(self);
end;

function fireworkPlaceable:deleteFinal()
    fireworkPlaceable:superClass().deleteFinal(self);
end;

function fireworkPlaceable:load(xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom)
    if not fireworkPlaceable:superClass().load(self, xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom) then
        return false;
    end;
    if not moveMode then   
        local xmlFile = loadXMLFile("TempXML", xmlFilename);
        self.Rocket = Utils.indexToObject(self.nodeId,"1");
        self.RocketVis = Utils.indexToObject(self.nodeId,"1|0");

        self.ParticleSyS = {};
        local psys = {};
        Utils.loadParticleSystem(xmlFile,psys,"placeable.ParcticleSySs.ParcticleSyS(0)",self.nodeId,false,nil,self.baseDirectory);
        self.ParticleSyS[1] = psys;
        local psys = {};
        Utils.loadParticleSystem(xmlFile,psys,"placeable.ParcticleSySs.ParcticleSyS(1)",self.nodeId,false,nil,self.baseDirectory);
        self.ParticleSyS[2] = psys;
        local psys = {};
        Utils.loadParticleSystem(xmlFile,psys,"placeable.ParcticleSySs.ParcticleSyS(2)",self.nodeId,false,nil,self.baseDirectory);
        self.ParticleSyS[3] = psys;
        local psys = {};
        Utils.loadParticleSystem(xmlFile,psys,"placeable.ParcticleSySs.ParcticleSyS(3)",self.nodeId,false,nil,self.baseDirectory);
        self.ParticleSyS[4] = psys;
        local psys = {};
        Utils.loadParticleSystem(xmlFile,psys,"placeable.ParcticleSySs.ParcticleSyS(4)",self.nodeId,false,nil,self.baseDirectory);
        self.ParticleSyS[5] = psys;
        local psys = {};
        Utils.loadParticleSystem(xmlFile,psys,"placeable.ParcticleSySs.ParcticleSyS(5)",self.nodeId,false,nil,self.baseDirectory);
        self.ParticleSyS[6] = psys;
        local psys = {};
        Utils.loadParticleSystem(xmlFile,psys,"placeable.ParcticleSySs.ParcticleSyS(6)",self.nodeId,false,nil,self.baseDirectory);
        self.ParticleSyS[7] = psys;
        local psys = {};
        Utils.loadParticleSystem(xmlFile,psys,"placeable.ParcticleSySs.ParcticleSyS(7)",self.nodeId,false,nil,self.baseDirectory);
        self.ParticleSyS[8] = psys;
        
        self.StartSound = createAudioSource("StartSound",Utils.getFilename("Start.wav", self.baseDirectory), 50, 1, 1, 1);
        link(self.Rocket, self.StartSound);
        setVisibility(self.StartSound, false);
        
        self.ExplodeSound = createAudioSource("ExplodeSound",Utils.getFilename("Explosion.wav", self.baseDirectory), 200, 1, 1, 1);
        link(self.Rocket, self.ExplodeSound);
        setVisibility(self.ExplodeSound, false);
        
        delete(xmlFile);
        self.MoveUP = false;
        self.NexShot = true;
        self.count = 0;
        self.countB = 0;
        self.shootCount = 0;
        self.shoot = false;
        self.Random = math.random(2,8);
        self.MaxHeight = math.random(30,60);
        local twocolor = math.random(0,1);
        local r=self:randomFloat();
        local g=self:randomFloat();
        local b=self:randomFloat();    
        for _, v in ipairs(self.ParticleSyS[self.Random]) do
            if(twocolor == 1) then
                r=self:randomFloat();
                g=self:randomFloat();
                b=self:randomFloat();          
            end;
            setShaderParameter(v.shape, "partScale", r, g, b, 0, false)
        end;
    end;
    return true;
end;

function fireworkPlaceable:update(dt)
    g_currentMission:addHelpButtonText("Feuerwerk Starten", InputBinding.IMPLEMENT_EXTRA)
    if self.shootCount ~= nil and self.shootCount > 0 then
        g_currentMission:addHelpButtonText(string.format("Restschuesse: %s",tostring(self.shootCount)),InputBinding.IMPLEMENT_EXTRA);
    end;
    if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
        self.shootCount = self.shootCount + 10;
    end;
    if self.shootCount > 0 and self.NexShot and not self.MoveUP then
        self.MoveUP = true;
        setVisibility(self.StartSound, true);
        Utils.setEmittingState(self.ParticleSyS[1], true);
        self.shootCount = (self.shootCount-1);
    end;
    if not self.NexShot and (self.shootCount > 0) then
        self.countB = (self.countB+1);
        if self.countB >= 30 then
            self.NexShot = true;
            self.countB = 0;
        end;
    end;
    if self.MoveUP then
        local x,y,z = getTranslation(self.Rocket);
        if (y < self.MaxHeight) then
            setTranslation(self.Rocket,0,(y+0.65),0);
            if (y+0.65) >= self.MaxHeight then
                setVisibility(self.StartSound, false);
                setVisibility(self.RocketVis, false);
                Utils.setEmittingState(self.ParticleSyS[1], false);
            end;
        else
            self.count = (self.count+1);
            if self.shoot == false then
                if self.count > 20 then
                    Utils.setEmittingState(self.ParticleSyS[self.Random], true);
                    setVisibility(self.ExplodeSound, true);
                    self.shoot = true;
                    self.count = 0;
                end;
            end;
            if self.count >= 200 then
                Utils.resetNumOfEmittedParticles(self.ParticleSyS[self.Random]);
                Utils.setEmittingState(self.ParticleSyS[self.Random], false);
                local twocolor = math.random(0,1);
                local r=self:randomFloat();
                local g=self:randomFloat();
                local b=self:randomFloat();  
                for _, v in ipairs(self.ParticleSyS[self.Random]) do
                    if(twocolor == 1) then
                        r=self:randomFloat();
                        g=self:randomFloat();
                        b=self:randomFloat();               
                    end;
                    setShaderParameter(v.shape, "partScale", r, g, b, 0, false)
                end;
                setTranslation(self.Rocket,0,0,0);
                setVisibility(self.RocketVis, true);
                self.count = 0;
                setVisibility(self.ExplodeSound, false);
                self.Random = math.random(2,8);
                self.MaxHeight = math.random(30,60);
                self.NexShot = false;
                self.MoveUP = false; 
                self.shoot = false;
            end;
        end;
    end;
end;

function fireworkPlaceable:randomFloat()
    return 1 + math.random()  * (10 - 1);
end
registerPlaceableType("fireworkPlaceable", fireworkPlaceable);